(function ($) {

  Drupal.behaviors.evanced_events_importer_toggle = {
  attach: function(context) {

    // One of the add/remove buttons was just clicked.
    $('.toggle_buttons .button').click(function() {

      // Define the selected XML element and target field.
      var action = $(this).attr('data-action');
      var field = $(this).attr('data-field');
      var elements = $('[name="exml_list[]"]').val() + '';
          elements = elements.split(',');
      var fieldValue = $('[name="field_' + field + '_select[]"]').val() + '';
          fieldValue = fieldValue.split(',');

      // If this is an add button...
      if ( action === 'add' ) {

        // If at lease one element is selected...
        if ( elements[0] !== 'null' ) {

          // Note the option limit (size) of the target field.
          var optionLimit = $('[name="field_' + field + '_select[]"]').attr('size');

          // Loop through selected elements.
          for (var i = 0; i < elements.length; i++) {

            // Note the number of option elements already in the target field.
            var optionCount = $('[name="field_' + field + '_select[]"] option').length;

            // If target field has fewer options than its limit...
            if ( optionCount < optionLimit ) {

              // Add the selected element to the target field.
              $('[name="field_' + field + '_select[]"]').append('<option value="' + elements[i] + '">' + elements[i] + '</option>');

              // Get current value of the hidden target field.
              var currentValue = $('[name="field_' + field + '_list"]').val();

              // Append new element to target field variable.
              currentValue = currentValue + ',' + elements[i];

              // Clean up duplicate commas in target field variable.
              currentValue = currentValue.replace(/(,+)/g,',');

              // Clean up trailing or leading commas in target field variable.
              currentValue = currentValue.replace(/(^,)|(,$)/g,'');

              // Update hidden target field.
              $('[name="field_' + field + '_list"]').val( currentValue );

              // Remove the selected element from the source field.            
              $('[name="exml_list[]"] option[value="' + elements[i] + '"]').remove();

            }

          }

        }
        // Else, no elements were selected.
        else {

          alert('Please select an EXML element to add to this field.');

        }

      }
      // Else, if this is a remove button...
      else if ( action === 'remove' ) {

        // If at lease one element is selected...
        if ( fieldValue[0] !== 'null' ) {
          
          // Loop through selected elements.
          for (var i = 0; i < fieldValue.length; i++) {

            // Add the selected element to the target field.
            $('[name="exml_list[]"]').append('<option value="' + fieldValue[i] + '">' + fieldValue[i] + '</option>');

            // Remove the selected element from the source field.
            $('[name="field_' + field + '_select[]"] option[value="' + fieldValue[i] + '"]').remove();

            // Get current value of the hidden source field.
            var currentValue = $('[name="field_' + field + '_list"]').val();

            // Remove element from source field variable.
            currentValue = currentValue.replace(fieldValue[i],'');

            // Clean up duplicate commas in target field variable.
            currentValue = currentValue.replace(/(,+)/g,',');

            // Clean up trailing or leading commas in target field variable.
            currentValue = currentValue.replace(/(^,)|(,$)/g,'');

            // Update hidden source field.
            $('[name="field_' + field + '_list"]').val( currentValue );

          }

        }
        // Else, no elements were selected.
        else {

          alert('Please select an EXML element to remove from this field.');

        }

      }

    });

  }

  }

})(jQuery);