<?php

namespace Drupal\evanced_events_importer\Controller;

/**
 * Define Evanced Events Importer Configuration functions.
 */
class Configuration {

  /**
   * Retrieves Evanced Events Importer configuration settings.
   */
  public static function getConfigurationSettings() {

    // Get stored configuration settings.
    $configuration = \Drupal::config('evanced_events_importer.settings');

    // Define form fields array.
    $config_variables_array = array(
      'feed_url',
      'content_type',
      'publisher_uid',
      'input_format',
      'force_update_flag',
      'striplinks_flag',
      'relative_links_domain',
      'log_events',
    );

    // Loop through configuration variables array.
    foreach ($config_variables_array as $variable) {
      // Define configuration variables.
      $config[$variable] = $configuration->get($variable);
    }

    // Define field_map array.
    $config['field_map'] = unserialize($configuration->get('field_map'));

    // If a field_map was provided.
    if (count($config['field_map']) > 0) {

      // Loop through fields in $field_map.
      foreach ($config['field_map'] as $field => $attributes_array) {

        // Loop through attributes is $attributes_array.
        foreach ($attributes_array as $attribute) {

          // If this attribute is "time".
          if ($attribute == 'time') {

            // Store this field name as $entity_start_field.
            $config['entity_start_field'] = $field;

          }

          // If this attribute is "id".
          if ($attribute == 'id') {

            // Store this field name as $entity_id_field.
            $config['entity_id_field'] = $field;

          }

        }

      }

    }

    // Return settings.
    return $config;

  }

}
